: *************************************************************************
:
: This script launches the search indexer, which indexes all of the 
: documentation in the application directory tree (.htm, .html, .pdf, and .txt files).
:
: NOTE: Shut down the application server before reindexing.
:
: *************************************************************************
@echo off

:: Check for JAVA_HOME 

if "%JAVA_HOME%" =="" goto setJava_Home ELSE 
goto :checkJava
  

::::::::::: System doesn't has JAVA_HOME environment variable.
:setJava_Home   
echo Set the JAVA_HOME variable either in your environment or in this script.
SET JAVA_HOME=C:\Change_To_Your_JDK_Directory
::::::::::

:checkJava
:: Check that Java is located where specified
if exist "%JAVA_HOME%\bin\java.exe" goto setClassPath
echo Your JAVA_HOME variable is set to: %JAVA_HOME%
echo The Java executable wasn't found in directory %JAVA_HOME%\bin.
echo Please edit your script so that the JAVA_HOME variable points to the location of your JDK.
pause
goto finish

:setClassPath
SET CLASSPATH=%CLASSPATH%;..\WEB-INF\lib\lucene-1.4.2.jar;..\WEB-INF\lib\lucene-demos-1.4.2.jar;..\WEB-INF\lib\PDFBox-0.7.1.jar;..\WEB-INF\lib\log4j-1.2.9.jar

:backupOldIndex
if exist indexOld del /q indexoLD\*.*
echo Backing up old index ...
mkdir indexOld
xcopy index\core indexOld

:deleteOldIndex
echo Deleting old index from index\core ...
del /q index\core\*.*

:
:runIndexer
"%JAVA_HOME%\bin\java" org.apache.lucene.demo.IndexHTML -create -index .\index\core -language English -pdf -xdir excludedirectories.txt -xfile excludefiles.txt ../

:where:
: -create    Specifies creation of the index.
:
: -index     Specifies the location of the index. You must specify a
:            subdirectory of .\index. If the subdirectory doesn't exist,
:            the indexer will create it for you.
:
: -language  Optional. Specifies the language analyzer to use. 
:            If your indexing non-English files and have the matching analyzer, set to
:            the applicable language. Defaults to English if excluded.
:
: -xdir      Optional. References one or more configuration files that list directories to 
:            exclude from indexing. You can reference multiple files in this format:
:            -xdir exclude1.txt+exclude2.txt+exclude3.txt...
:            For syntax requirements on excluding directories, see excludedirectories.txt.
:
: -xfile     Optional. References one or more text files that list files to exclude from indexing.
:            You can reference multiple files in this format:
:            -xfile exclude1.txt+exclude2.txt+exclude3.txt...
:            For syntax requirements on excluding files, see excludefiles.txt.
:
: -pdf       Optional. Specifies indexing of PDF files.
:
: ../        Indicates that indexing should start at the root directory of the documentation
:            directory tree (ecm_help by default). Typically you would not want to change the
:            default directory specifier (../).

:finish
