// JavaScript Lucene Query Validator
// Author: Kelvin Tan  (kelvin@relevanz.com)
// Date:   10/04/2002
// Updated for FileNET by Frank Eichenlaub


// validates a lucene query.
// @param Form field that contains the query
function doCheckLuceneQuery(queryField)
{
//alert ("in validator: "+queryField);
  var query = queryField; //queryField.value;

// check for empty query (no characters)
   if(query == "") //query.charCodeAt(0) == 32 || 
  {
    alert("잘못된 검색 쿼리입니다. 검색 문자열을 입력하십시오.");
	return false;
  }
  
  if(query != null && query.length > 0)
  {
    // check for a query with all spaces
    //var matches = query.match(/[^\w] | [^a-zA-Z0-9\*\?\+\-]/);
	var matches = query.match(/([a-zA-Z0-9\*\?\+\-])|(\w\x20)|(\x20\w)]/);

	if(matches == null)
    {
      alert("잘못된 검색 쿼리입니다. 검색 문자열에 영숫자를 포함시키십시오.")
      return false;
    }
	
	
	// check '*' wildcard is used properly
	 var matches = query.match(/^(\*)|([^\w\.]\*)/);
    
    if(matches != null && matches.length > 0)
    {
      alert("잘못된 검색 쿼리입니다. 와일드카드(*) 문자 앞에 영숫자가 하나 이상 있어야 합니다. 다시 시도하십시오.")
      return false;
    }
	
	matches = query.match(/^(\?)|([^\w\.]\?)/);

    // check '?' wildcard is used properly
    if(matches != null && matches.length > 0)
    {
      alert("잘못된 검색 쿼리입니다. 와일드카드(?) 문자 앞에 영숫자가 하나 이상 있어야 합니다. 다시 시도하십시오.")
      return false;
    }
		

    // check parentheses are used properly
    matches = query.match(/^([^\n()]*|(\(([\?\sa-zA-Z0-9_+\-:()\"]|\*)+\)))*$/);
    if(matches == null || matches.length == 0)
    {
      alert("잘못된 검색 쿼리입니다. 영숫자를 하나 이상 괄호로 묶어야 합니다. 다시 시도하십시오.")
      return false;
    }

    // check '+' and '-' are used properly      
	//matches = query.match(/^(([^\n+-]*|[+-]([a-zA-Z0-9_:()]|)+))$/);
	matches = query.match(/(\+$|\+[^a-zA-Z0-9_:\(\)])|(-$|-[^a-zA-Z0-9_:\(\)])/);//

    if(matches != null)
    {
      alert("잘못된 검색 쿼리입니다. '+'와 '-' 수정자 다음에 영숫자가 하나 이상 있어야 합니다. 다시 시도하십시오.")
      return false;
    }  



    // check that quote marks are closed
  matches = query.match(/\"/g);
    if(matches != null)
    {
      var number = matches.length;
      if((number % 2) > 0)
      {
        alert("잘못된 검색 쿼리입니다. 모든 따옴표 (\") 표시를 닫으십시오.");
        return false;
      }
    }

    // check ':' is used properly
      matches = query.match(/^(([^\n:]*|([a-zA-Z0-9_]|\*)+[:]([a-zA-Z0-9_()"]|\*)+))*$/);
    if(matches == null || matches.length == 0)
    {
      alert("잘못된 검색 쿼리입니다. 필드 선언(:) 앞과 뒤에 각각 영숫자가 하나 이상 있어야 합니다. 다시 시도하십시오.")
      return false;
    }

    return true;
  }
}
